/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.api.event;

import alexiil.mc.lib.attributes.mixin.api.UnloadableBlockEntity;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_2680;

/** Fired when the state of a container's block entity changes. Listen for subclasses, not this one! */
public abstract class PartContainerState extends MultipartEvent {
    /** Fired in {@link class_2586#method_11012()} */
    public static final Invalidate INVALIDATE = new Invalidate();

    /** Fired in {@link class_2586#method_10996()} */
    public static final Validate VALIDATE = new Validate();

    /** Fired in {@link UnloadableBlockEntity#onChunkUnload()}. In 1.17 this is fired before
     * {@link PartContainerState.Invalidate}, which always follows this. */
    public static final ChunkUnload CHUNK_UNLOAD = new ChunkUnload();

    /** Fired in {@link class_2248#method_9536(class_2680, class_1937, class_2338, class_2680, boolean)} */
    public static final Remove REMOVE = new Remove();

    PartContainerState() {}

    /** Fired in {@link class_2586#method_11012()} */
    public static final class Invalidate extends PartContainerState implements ContextlessEvent {
        Invalidate() {}
    }

    /** Fired in {@link class_2586#method_10996()} */
    public static final class Validate extends PartContainerState implements ContextlessEvent {
        Validate() {}
    }

    /** Fired in {@link UnloadableBlockEntity#onChunkUnload()}. In 1.17 this is fired before
     * {@link PartContainerState.Invalidate}, which always follows this. */
    public static final class ChunkUnload extends PartContainerState implements ContextlessEvent {
        ChunkUnload() {}
    }

    /** Fired in {@link class_2248#method_9536(class_2680, class_1937, class_2338, class_2680, boolean)} */
    public static final class Remove extends PartContainerState implements ContextlessEvent {
        Remove() {}
    }
}
