/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.mixin.api;

import java.util.Map;
import java.util.Map.Entry;

import javax.annotation.Nullable;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_238;
import net.minecraft.class_243;
import net.minecraft.class_259;
import net.minecraft.class_265;
import net.minecraft.class_2680;

public interface IBlockSimpleMultipart<T> extends IBlockMultipart<T> {

    Map<T, class_265> getSubParts(class_1936 world, class_2338 pos, class_2680 state);

    @Override
    @Nullable
    default T getTargetedMultipart(class_2680 state, class_1937 w, class_2338 pos, class_243 hitVec) {
        Map<T, class_265> map = getSubParts(w, pos, state);

        for (Entry<T, class_265> entry : map.entrySet()) {
            class_265 shape = entry.getValue();
            for (class_238 box : shape.method_1090()) {
                if (box.method_1014(0.01).method_1006(hitVec)) {
                    return entry.getKey();
                }
            }
        }
        return null;
    }

    @Override
    default class_265 getPartOutlineShape(class_2680 state, class_1937 world, class_2338 pos, class_243 hitVec) {
        T targetted = getTargetedMultipart(state, world, pos, hitVec);
        if (targetted == null) {
            return class_259.method_1073();
        }
        return getSubParts(world, pos, state).get(targetted);
    }
}
