/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.mixin.impl;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import alexiil.mc.lib.multipart.mixin.api.IBlockCustomParticles;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_239;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_638;
import net.minecraft.class_702;

@Mixin(class_702.class)
public class ParticleManagerMixin {

    @Inject(at = @At("HEAD"),
        method = "addBlockBreakingParticles(Lnet/minecraft/util/math/BlockPos;Lnet/minecraft/util/math/Direction;)V",
        cancellable = true)
    private void addBlockBreakingParticles(class_2338 pos, class_2350 side, CallbackInfo ci) {
        class_310 mc = class_310.method_1551();
        class_638 w = mc.field_1687;
        if (w == null) {
            return;
        }
        class_2680 state = w.method_8320(pos);
        class_2248 block = state.method_26204();
        if (block instanceof IBlockCustomParticles) {
            IBlockCustomParticles pb = (IBlockCustomParticles) block;
            class_239 target = mc.field_1765;
            class_243 hitVec = target != null ? target.method_17784() : class_243.method_24953(pos);
            if (pb.spawnBreakingParticles(w, pos, state, side, hitVec)) {
                ci.cancel();
            }
        }
    }
}
