/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.mixin.impl;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.ModifyArg;
import alexiil.mc.lib.multipart.mixin.api.IBlockMultipart;
import net.minecraft.class_2338;
import net.minecraft.class_239.class_240;
import net.minecraft.class_243;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_3965;
import net.minecraft.class_638;
import net.minecraft.class_761;

@Mixin(class_761.class)
public class WorldRendererMixin {

    private static final String WORLD_RENDERER = "Lnet/minecraft/client/render/WorldRenderer;";

    private static final String MATRIX_STACK = "Lnet/minecraft/client/util/math/MatrixStack;";
    private static final String VERTEX_CONSUMER = "Lnet/minecraft/client/render/VertexConsumer;";
    private static final String ENTITY = "Lnet/minecraft/entity/Entity;";
    private static final String VOXEL_SHAPE = "Lnet/minecraft/util/shape/VoxelShape;";
    private static final String BLOCK_POS = "Lnet/minecraft/util/math/BlockPos;";
    private static final String BLOCK_STATE = "Lnet/minecraft/block/BlockState;";

    private static final String CAMERA = "Lnet/minecraft/client/render/Camera;";
    private static final String GAME_RENDERER = "Lnet/minecraft/client/render/GameRenderer;";
    private static final String LIGHTMAP_TEXTURE_MANAGER = "Lnet/minecraft/client/render/LightmapTextureManager;";
    private static final String MATRIX4F = "Lnet/minecraft/util/math/Matrix4f;";

    private static final String _M_DRAW_BLOCK_OUTLINE
        = "drawBlockOutline(" + MATRIX_STACK + VERTEX_CONSUMER + ENTITY + "DDD" + BLOCK_POS + BLOCK_STATE + ")V";

    private static final String _M_DRAW_SHAPE_OUTLINE
        = "drawShapeOutline(" + MATRIX_STACK + VERTEX_CONSUMER + VOXEL_SHAPE + "DDDFFFF)V";

    @Shadow
    private class_638 world;

    @ModifyArg(at = @At(value = "INVOKE", target = WORLD_RENDERER + _M_DRAW_SHAPE_OUTLINE),
        method = WORLD_RENDERER + _M_DRAW_BLOCK_OUTLINE)
    private class_265 modifyShape(class_265 shape) {
        class_310 mc = class_310.method_1551();
        if (mc.field_1765 != null && mc.field_1765.method_17783() == class_240.field_1332) {
            class_3965 bhit = (class_3965) mc.field_1765;
            class_2338 bpos = bhit.method_17777();
            class_243 bvec = bhit.method_17784();
            class_2680 state = world.method_8320(bpos);
            if (state.method_26204() instanceof IBlockMultipart<?>) {
                IBlockMultipart<?> multipart = ((IBlockMultipart<?>) state.method_26204());
                class_265 partShape = multipart.getPartOutline(state, world, bpos, bvec);
                if (!partShape.method_1110()) {
                    return partShape;
                }
            }
        }

        return shape;
    }
}
